
function copyFileFromJar( szJarFile, szFileName , szLocalFileName) {

	const FileFactory = new Components.Constructor("@mozilla.org/file/local;1","nsILocalFile","initWithPath");
  	dump("Step 1\n");
	var jarfile = new FileFactory( szJarFile );
  	dump("Step 2\n");
	var localFile = new FileFactory( szLocalFileName );

  	dump("Step 3\n");
	var zipReader = Components.classes["@mozilla.org/libjar/zip-reader;1"].createInstance(Components.interfaces.nsIZipReader);
  	dump("Step 4\n");

    zipReader.init(jarfile);
    zipReader.open();
    zipReader.test(null);
	zipReader.extract( szFileName , localFile );
	zipReader.close();
	
}


function downloadFromJarUrl( szJarURL, szLocalFileName) {

	var JarHandler = Components.classes["@mozilla.org/network/protocol;1?name=jar"].createInstance(Components.interfaces.nsIJARProtocolHandler);
	
	JarHandler.newChannel ( szJarURL , channel );
	channel.open( stream );
	
	var JARCache = JarHandler.JARCache ;
	
	

    zipReader.init(jarfile);
    zipReader.open();
    zipReader.test(null);
	zipReader.extract( szFileName , localFile );
	zipReader.close();
	
}



function downloadFileFromUrl( fileUrl , localFolderName , fileName) {

	const FileFactory = new Components.Constructor("@mozilla.org/file/local;1","nsILocalFile","initWithPath");
  	const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
  	
  
  	//try {
    	dump("Step0\n");
		// set up target destination for download
		dump( "Local folder is : " + localFolderName + "\n" );
		var dest = new FileFactory( localFolderName );
		dump( "filename is : " + fileName + "\n" );		
		dest.append( fileName );
		if (!dest.exists()) {
			dest.create(dest.NORMAL_FILE_TYPE, 0777);
		}
    
    	dump("Step1\n");
    
		// set up source
		var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		uri.spec = fileUrl;

    	dump("Step2\n");

		var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowser;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);

    	dump("Step3\n");

		var flags = nsIWBP.PERSIST_FLAGS_NO_CONVERSION | nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;

    	dump("Step4\n");
		
		persist.persistFlags = flags;
		
    	dump("Step5\n");
    	
		persist.progressListener = new PersistProgressListener;
		
    	dump("Step6\n");
    	
		persist.saveURI(uri, null, null, null, null, dest);
		
    	dump("Step7\n");

	//} catch(e) { 
	//	throw("Download failed.");
	//}
}

function PersistProgressListener() { dump("PersistProgressListenerCreated\n");}
PersistProgressListener.prototype = {

	QueryInterface : function(aIID) {
		if(aIID.equals(Components.interfaces.nsIWebProgressListener))
		return this;
		throw Components.results.NS_NOINTERFACE;
	},

	init : function() {},
	destroy : function() {},

	onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus) {
		if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
			dump("Downloaded\n");
		}
	},

	onProgressChange : function (aWebProgress, aRequest,
					   aCurSelfProgress, aMaxSelfProgress,
					   aCurTotalProgress, aMaxTotalProgress) {},
	onLocationChange : function(aWebProgress, aRequest, aLocation) {},
	onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange : function(aWebProgress, aRequest, aState) {}
}
