/**


*/


/* By default list the products */
function displayProducts(){

	var sqlCmd = "select keyCode, Name , Version from Products";

	var nsView = nsDb.Execute( sqlCmd );
	dump("\n\ninstalled Products (ID,Name,Version)\n");
	dump("------------------------------------\n");
	var rec = nsView.Fetch();
	while( rec ) {
		dump(  rec.Field(0) + "\t" + rec.Field(1) + "\t" + rec.Field(2) + "\n" );
		rec = nsView.Fetch();
	}
}


function displayAllPackages(){

	var sqlCmd = "select keyCode, Name , Version from Packages";

	var nsView = nsDb.Execute( sqlCmd );
	dump("\n\ninstalled Packages (ID,Name,Version)\n");
	dump("------------------------------------\n");
	var rec = nsView.Fetch();
	while( rec ) {
		dump(  rec.Field(0) + "\t" + rec.Field(1) + "\t" + rec.Field(2) + "\n" );
		rec = nsView.Fetch();
	}
}

function displayPackages( prdId )
{

	var sqlCmd = "select keyCode, Name , Version from Packages where keyCode in ( select Child from Dependencies where Parent = '"+prdId+"')";

	var nsView = nsDb.Execute( sqlCmd );
	dump("\n\ninstalled packages (ID,Name,Version)\n");
	dump("------------------------------------\n");
	var rec = nsView.Fetch();
	while( rec ) {
		dump(  rec.Field(0) + "\t" + rec.Field(1) + "\t" + rec.Field(2) + "\n" );
		rec = nsView.Fetch();
	}

}


function displayLog( )
{

	var sqlCmd = "select type , key , name , version ,date,  user , action , status from Audit";

	var nsView = nsDb.Execute( sqlCmd );
	dump("\n\nAction Log (type, ID, name, version, date, user, action, status )\n");
	dump("----------------------------------------------------------------------\n");
	var rec = nsView.Fetch();
	while( rec ) {
		dump(  rec.Field(0) + ", " + rec.Field(1) + ", " + rec.Field(2) + ", " + rec.Field(3) +", " + rec.Field(4) +", " + rec.Field(5) +", " + rec.Field(6) +", " + rec.Field(7) +"\n" );
		rec = nsView.Fetch();
	}

}


function usage(){

	dump("\n\n");
	dump("Usage:\n");
	dump("------\n");	
	dump("\n");
	dump("UNIX:ncisetup -report [<product id>|all|log]\n");	
	dump("   or\n");
	dump("WINDOWS:setup.com -report [<product id>|all|log]\n");	
	dump("\n");
	dump("Use -report all to get a list of products and packages (default).\n");
	dump("Use -report <productId> to list packages referenced by a product.\n");
	dump("Use -report log to get the audit log.\n");
	dump("\n");
	
}




// Having a package manager is important
PackageManager = Components.classes["@micromuse.com/NCIPackageManager;1"].getService(Components.interfaces.nsINCIPackageManager);

// Get the Property Manager too
PropMgr = Components.classes["@micromuse.com/NCIProperties;1"].getService(Components.interfaces.nsINCIProperties);				

// Read the command line interface
CmdLine = Components.classes["@mozilla.org/appshell/commandLineService;1"].getService(Components.interfaces.nsICmdLineService);
var productId = CmdLine.getCmdLineValue("-report");


PackageManager.Initialize();
var nsDb = Components.classes["@micromuse.com/NCISQLite;1"].getService(Components.interfaces.nsISQLiteDb);


if ( productId == "log" ) {
	displayLog();
	
} else if ( productId == "all" ) {
	displayProducts();
	displayAllPackages();

} else if (  productId == null || productId == "1" ) {
	usage();
	displayProducts();
	displayAllPackages();

} else {
	displayPackages( productId );
}
